using System;

namespace IdeaBlade.EntityModel {

  public class AlwaysCompleted : INotifyCompleted {

    public static AlwaysCompleted Instance {
      get { return _instance ?? (_instance = new AlwaysCompleted()); }
    }

    private static AlwaysCompleted _instance;

    public void WhenCompleted(Action<INotifyCompletedArgs> completedAction) {
      completedAction(new AlwaysCompletedArgs());
    }

    private class AlwaysCompletedArgs : INotifyCompletedArgs {
      public Exception Error { get { return null; } }
      public bool Cancelled { get { return false; } }
      public bool IsErrorHandled { get; set; }
    }
  }

}