Namespace IdeaBlade.EntityModel

  Public Class AlwaysCompleted
	  Implements INotifyCompleted

    Public Shared ReadOnly Property Instance() As AlwaysCompleted
      Get
        If _instance IsNot Nothing Then
          Return _instance
        Else
          _instance = New AlwaysCompleted()
          Return _instance
        End If
      End Get
    End Property

	Private Shared _instance As AlwaysCompleted

    Public Sub WhenCompleted(ByVal completedAction As Action(Of INotifyCompletedArgs)) Implements INotifyCompleted.WhenCompleted
      completedAction(New AlwaysCompletedArgs())
    End Sub

	Private Class AlwaysCompletedArgs
		Implements INotifyCompletedArgs
      Public ReadOnly Property [Error]() As Exception Implements INotifyCompletedArgs.Error
        Get
          Return Nothing
        End Get
      End Property
      Public ReadOnly Property Cancelled() As Boolean Implements INotifyCompletedArgs.Cancelled
        Get
          Return False
        End Get
      End Property
      Public Property IsErrorHandled() As Boolean Implements INotifyCompletedArgs.IsErrorHandled
    End Class
  End Class

End Namespace